from ..base import Base
from ..classes import Conversation
from .enum import Pack,Node
from .filteres import match_btn,match_text
from telegram.ext import Filters
from starco.tlg.bot.util.enum import *
from starco.tlg.bot.classes import Conversation
from starco.utils import path_maker
import telegram
from telegram.ext import Filters
from starco.tlg.app.utils import get_number,session_number
from starco.tlg.app import TlgApp
import threading,re,time
from functools import partial
import shutil
from starco.tlg.bot.util.filteres import FileFormat,match_btn
from starco.tlg.bot.util.functions import copy_ready_session

from starco.utils import chunks

def Start(self:Conversation):
    
    def act(self,*args):
        self.send(msg = 'start_pm', btns = self.menu_keys)
        return -1

    p = Pack()
    p.name = 'start'

    e1 = Node()
    e1.command = 'start'
    e1.command_filters = match_text('/start')
    e1.callback=act

    e2=Node()
    e2.pattern = self.check_inline_keyboards('/start')
    e2.callback = act
    p.entry=[e1,e2]
    return p

def SharePhone(self:Conversation):
    p = Pack()
    p.name = 'share_phone'
    e=Node()
    e.filters = Filters.contact
    def act(self,*args):
        contact = self.update.effective_message.contact
        phone = contact.phone_number
        self.db.do('users', {'id': self.id, 'phone': int(phone)}, condition=f"id={self.id}")
        self.send_message('phone_shared', self.menu_keys)
        return -1
    e.callback = act
    p.entry=[e]
    return p
            
def SelectLanguage(self:Conversation):
    p = Pack()
    p.name = 'select_language'
    e=Node()
    e.pattern = self.check_inline_keyboards('select_language',self)
    
    def act(self:Conversation,*args):
        lang_id = int(self.splited_query_data()[1])
        self.db.do('users', {'id': self.id, 'language': lang_id}, condition=f"id={self.id}")
        self.delete_message(self.get_msg_id())
        self.user_info=self.get_user_info_from_db([])
        self.send('✅ The language has been set', self.menu_keys,translat=False)
        return -1
    e.callback = act
    p.entry=[e]
    return p
            
def Referral(self:Conversation):
    p = Pack()
    p.name = 'Referral'
    p.db_config={'users':{'presenter':0}}

    e1 = Node()
    e1.btn = self.menu_keys
    e1.filters = match_btn('referral',self)
    
    def referral_text(self:Base,*args):
        msg=self.text('referral_text',slash=True)+'\n\n'
        msg+=f'https://t.me/{self.super_self.bot_username}?start=ref{self.id}\n\n'
        msg+=f"{self.text('invited')} : {len(self.db.do('users', condition=f'presenter={self.id}'))}"

        self.send(msg= msg,btns=self.menu_keys,translat=False)
        return -1
    e1.callback =referral_text

    e2 = Node()
    e2.btn = self.menu_keys
    e2.command = 'start'
    e2.command_filters=Filters.regex('/start ref\d+')
    def referral_action(self,*args):
        try:
            presenter = int(self.get_text().split(' ')[-1].replace('ref',''))
        except:
            try:
                presenter = int(self.splited_query_data()[1].split(' ')[-1].replace('ref',''))
            except:
                presenter=0
        try:
            submited_presenter = int(self.user('presenter'))
        except:
            submited_presenter = 0
        if submited_presenter==0 and presenter!=self.id:
            self.db.do('users', {'presenter': presenter},condition=f"id={self.id}")
            self.send('new_subset_text', chat_id=presenter)
        self.send('start_pm', self.menu_keys)
        return -1
    
    e2.callback=referral_action

    e3 = Node()
    e3.btn = self.menu_keys
    e3.pattern = self.check_inline_keyboards('/start ref',regex=True)
    e3.callback=referral_action


    p.entry=[e1,e2,e3]
    return p



def LoginTlgAccount(self:Conversation):
    p = Pack()
    p.name = 'login_tlg_account'
    p.db_config={'tlg_accounts':{'id':0,'u_id':0,'status':0,'messaging':0,'spam_check':0,'copied':0,'fastremove':0,'limit_status':'','limit_time':0,'last_check':0,'active_sessions':0,'time':0}}
    e=Node()
    e.filters = Filters.regex('\+\d{9,12}') | Filters.contact
    def act(self: Conversation, *args):
        self.userdata('tlg',delete=True)
        if Filters.contact(self.update):
            contact = self.update.effective_message.contact
            txt = contact.phone_number
        else:
            txt = self.get_text()
        last_msg_id = self.get_msg_id() 
        
        number = get_number(txt)
        if len(txt) > 8 and number and number > 0:
            db_ninfo = self.db.do('tlg_accounts', condition=f'id={number}')
            db_ninfo = [i for i in db_ninfo if i['status'] in [CONFIRMED,WAITING]]
            if db_ninfo:
                self.send('submit_before',self.menu_keys)
                return -1
            else:
                path_number=session_number(number)
                
                self.send('send_code_note',[[self.back_menu_key]],reply_to_message_id=last_msg_id)
                tlg = TlgApp(path_number, auto_connect=False)
                tlg.d['pm_msg_id'] =last_msg_id
                self.userdata('tlg', tlg)
                def action(self,tlg:TlgApp):
                    try:
                        tlg.connect()
                        out = tlg.do_login(True)
                        if out != '':
                            self.send(out,translat=False,reply_to_message_id=last_msg_id)
                    except:
                        self.send('try_again',reply_to_message_id=last_msg_id)
                threading.Thread(target=partial(action,self,tlg)).start()
                return self.stat_key('login_tlg_account', 0)

        else:
            self.send(self.text('bad_number',slash=True)+'\n'+self.text('menu_text',slash=True),translat=False,reply_to_message_id=last_msg_id)
            return -1
    e.callback = act


    def add_pendding(self: Conversation):
        tlg: TlgApp = self.userdata('tlg')
        tlg.ative_last_seen()
        tlg.disable_show_phone_number()
        tlg.disconnect()
        time.sleep(1)
        oid = get_number(tlg.number)
        cfg = {
            'id': oid,
            'u_id': self.id,
            'status': CONFIRMED,
            'messaging':1,
            'time': self.time()}
        self.db.do('tlg_accounts', cfg,condition=f"id={oid}")
        self.send(self.text('submited')+f'\n/tlg_{oid}',reply_to_message_id=tlg.d.get('pm_msg_id'))
        
    s2 = Node()
    s2.filters = Filters.text

    def act(self: Conversation, *args):
        code = self.get_text()
        if 'Login code' in code:
            find = re.findall('Login code: (\d{5}).',code)
            if find:
                code = find[0]
        tlg: TlgApp = self.userdata('tlg')
        if type(tlg)==type(None):
            self.send('try_again')
            return -1

        if len(code) >= 5 and type(tlg)!=type(None) and tlg.d.get('step')==2:
            code = int(re.search(r'\d+', str(code)).group())
            out = tlg.do_login(code=code)
            if out == '':
                add_pendding(self)
                return -1
            elif out == 'need_pass2':
                self.send(self.text(out,slash=True)+f"\n/cancel",translat=False,reply_to_message_id=tlg.d.get('pm_msg_id'))
                return self.stat_key('login_tlg_account', 1)
            else:
                number = tlg.number
                msg = self.text(out, slash=True)+f'\nnumber:{number}\n\n'
                msg += self.text('send_code', slash=True)

                self.send(msg+f"\n/cancel",translat=False,reply_to_message_id=tlg.d.get('pm_msg_id'))
                return self.stat_key('login_tlg_account', 0)

        else:
            self.send(self.text('send_code',slash=True)+f"\n/cancel",translat=False,reply_to_message_id=tlg.d.get('pm_msg_id'))
            return self.stat_key('login_tlg_account', 0)
    s2.callback = act

    s3 = Node()
    s3.filters = Filters.text

    def act(self: Conversation, *args):
        p2fa = self.get_text()
        
        tlg: TlgApp = self.userdata('tlg')
        out = tlg.do_login(p2fa=p2fa)
        if out == '':
            add_pendding(self)
            return -1
        else:
            msg = self.text(out, slash=True)+'\n'
            msg += self.text('need_pass2', slash=True)

            self.send(msg+f"\n/cancel",translat=False,reply_to_message_id=tlg.d.get('pm_msg_id'))
            return self.stat_key('login_tlg_account', 1)
    s3.callback = act

    p.entry=[e]
    p.states=[[s2], [s3]]

    return p

def ReloginTlgAccount(self:Conversation):
    p = Pack()
    p.name = 'relogin_tlg_account'

    e=Node()
    e.pattern = self.check_inline_keyboards('relogin')
    def act(self: Conversation, *args):
        last_msg_id = self.get_msg_id()
        number = get_number(self.splited_query_data()[-1])
        if number > 0:
            db_ninfo = self.db.do('tlg_accounts', condition=f'id={number}')
            db_ninfo = [i for i in db_ninfo if i['status'] in [CONFIRMED]]
            if not db_ninfo:
                self.send('session_not_active')
                return -1
            else:
                path_number=session_number(number)
                password_2fa= TlgApp(path_number,auto_connect=False).js('password_2fa')
                self.send(f"pass2:`{password_2fa}`",translat=False,parse_mode=telegram.ParseMode.MARKDOWN)
                tlg = TlgApp(path_number, auto_connect=False,path_list =['relogin',number], js_path_list =['relogin',number] )
                self.send('send_code_note',reply_to_message_id=last_msg_id)
                tlg.d['pm_msg_id'] =last_msg_id
                self.userdata('tlg', tlg)
                def action(self,tlg:TlgApp):
                    try:
                        tlg.connect()
                        out = tlg.do_login(True)
                        time.sleep(10)
                        otlg = TlgApp(tlg.number)
                        logcode = otlg.get_telegram_code()
                        otlg.disconnect()
                        self.send(f"`{logcode}`",translat=False,parse_mode=telegram.ParseMode.MARKDOWN)
                        # if str(len(logcode)>=5):
                        #     login_proccess = tlg.do_login(code=logcode)
                        #     print(login_proccess)
                        #     if login_proccess=='':
                        #         add_pendding(self)
                        #         return -1
                        #     elif login_proccess=='need_pass2':
                        #         password_2fa = otlg.js('password_2fa')
                        #         res_out=tlg.do_login(p2fa=password_2fa)
                        #         print(res_out)
                        #         if res_out=='':
                        #             add_pendding(self)
                        #             return -1
                        if out != '':
                            self.send(out,translat=False,reply_to_message_id=last_msg_id)
                    except:
                        self.send('try_again',reply_to_message_id=last_msg_id)
                threading.Thread(target=partial(action,self,tlg)).start()
                return self.stat_key('relogin_tlg_account', 0)

        else:
            self.send(self.text('bad_number',slash=True)+'\n'+self.text('menu_text',slash=True),translat=False,reply_to_message_id=last_msg_id)
            return -1
    e.callback = act


    def add_pendding(self: Conversation):
        tlg: TlgApp = self.userdata('tlg')
        tlg.ative_last_seen()
        tlg.disable_show_phone_number()
        tlg.disconnect()
        time.sleep(1)
        oid = get_number(tlg.number)
        self.db.do('tlg_accounts',{'copied':0},condition=f"id={oid}")
        temp_tlg = TlgApp(oid,auto_connect=False)
        shutil.move(tlg.path,temp_tlg.path)
        shutil.move(tlg.json_path,temp_tlg.json_path)
        self.send(self.text('done')+f'\n/tlg_{oid}',reply_to_message_id=tlg.d.get('pm_msg_id'))
        
    s2 = Node()
    s2.filters = Filters.text

    def act(self: Conversation, *args):
        code = self.get_text()
        if 'Login code' in code:
            find = re.findall('Login code: (\d{5}).',code)
            if find:
                code = find[0]
        tlg: TlgApp = self.userdata('tlg')
        if type(tlg)==type(None):
            self.send('try_again')
            return -1

        if len(code) >= 5 and type(tlg)!=type(None) and tlg.d.get('step')==2:
            code = int(re.search(r'\d+', str(code)).group())
            out = tlg.do_login(code=code)
            if out == '':
                add_pendding(self)
                return -1
            elif out == 'need_pass2':
                self.send(self.text(out,slash=True)+f"\n/cancel",translat=False,reply_to_message_id=tlg.d.get('pm_msg_id'))
                return self.stat_key('relogin_tlg_account', 1)
            else:
                number = tlg.number
                msg = self.text(out, slash=True)+f'\nnumber:{number}\n\n'
                msg += self.text('send_code', slash=True)

                self.send(msg+f"\n/cancel",translat=False,reply_to_message_id=tlg.d.get('pm_msg_id'))
                return self.stat_key('relogin_tlg_account', 0)

        else:
            self.send(self.text('send_code',slash=True)+f"\n/cancel",translat=False,reply_to_message_id=tlg.d.get('pm_msg_id'))
            return self.stat_key('relogin_tlg_account', 0)
    s2.callback = act

    s3 = Node()
    s3.filters = Filters.text

    def act(self: Conversation, *args):
        p2fa = self.get_text()
        
        tlg: TlgApp = self.userdata('tlg')
        out = tlg.do_login(p2fa=p2fa)
        if out == '':
            add_pendding(self)
            return -1
        else:
            msg = self.text(out, slash=True)+'\n'
            msg += self.text('need_pass2', slash=True)

            self.send(msg+f"\n/cancel",translat=False,reply_to_message_id=tlg.d.get('pm_msg_id'))
            return self.stat_key('relogin_tlg_account', 1)
    s3.callback = act

    p.entry=[e]
    p.states=[[s2], [s3]]

    return p

def CopySession(self:Conversation):
    p=Pack()
    p.name = 'copy_session'
    e =Node()
    e.filters=FileFormat('zip')
    def act(self:Conversation,*args):
        file = self.update.effective_message.effective_attachment
        file_name= file.file_name
        if '.zip' in file_name:
            zip_path = path_maker(['temp'],'.')
            info = self.bot.get_file(file.file_id)
            zip_path=info.download(zip_path+f"/{info.file_path.split('/')[-1]}")
            saved_before = [i['id'] for i in self.db.do('tlg_accounts', condition=f'status={CONFIRMED}')]
            numbers = copy_ready_session(zip_path,saved_before)
            for number in numbers:
                tlg = TlgApp(number,disable_proxy=True,auto_connect=False)
                tlg.remove_proxy()
                tlg.connect()
                status =tlg.get_status()
                if status:
                    tlg.ative_last_seen()
                    tlg.disable_show_phone_number()
                    oid = get_number(tlg.number_int)
                    cfg = {
                        'id': oid,
                        'u_id': self.id,
                        'status': CONFIRMED,
                        'copied':1,
                        'messaging':1,

                        'time': self.time()}
                    self.db.do('tlg_accounts', cfg,condition=f"id={oid}")
                    self.send(self.text('submited')+f'\n/tlg_{oid}')
                else:self.send(f"{number} "+self.text('session_not_active',slash=True))
        return -1
    
    e.callback =act
    p.entry=[e]

    return p

def ToggleSetting(self:Conversation,**kargs):
    p=Pack()
    key = kargs.get('key','toggle_setting')
    p.name = key
    def setting_msg_btn(self):
        setting = self.db.do('setting',condition=f"subset='{key}'")
        msg=''
        btn={}
        for i in setting:
            msg+=f"{self.text(i['key'],slash=True)} : {self.text(i['value'])}\n"
            btn[i['key']]=key
        return msg,btn

    e=Node()
    e.filters = match_btn(key,self)
    def act(self:Conversation,*args):
        msg,btn = setting_msg_btn(self)
        self.send(msg,btn,translat=False)
        return self.stat_key(key,0)
    e.callback=act

    s=Node()
    s.pattern = self.check_inline_keyboards(key)
    def act(self:Conversation,*args):
        k = self.splited_query_data()[0]
        res = self.toggle('setting','value',k,'key',['0','1'])
        self.alert(self.text(res))
        msg,btn = setting_msg_btn(self)
        self.edit_message_text(msg,self.get_msg_id(),btn)
        return self.stat_key(key,0)
    s.callback=act

    p.entry=[e]
    p.states=[[s]]

    return p
    
def Setting(self:Conversation,**kargs):
    p=Pack()
    key = kargs.get('key','public_setting')
    p.name = key

    def setting_msg_btn(self):
        setting = self.db.do('setting',condition=f"subset='{key}'")
        msg=''
        btn=[]
        for i in setting:
            if i.get('hide')!=1:
                msg+=f"{self.text(i['key'],slash=True)} : \n{i['value']} {i['unit']}\n---\n"
            btn+=[i['key']]
        if msg=='':msg=self.text('select_option',slash=True)
        return msg,btn

    e=Node()
    e.filters = match_btn(key,self)
    def act(self:Conversation,*args):
        msg,btn = setting_msg_btn(self)
        btn+=[self.back_menu_key]
        self.send(msg,chunks(btn,2),translat=False)
        return self.stat_key(key,0)
    e.callback=act

    s=Node()
    s.filters = Filters.text
    def act(self:Conversation,*args):
        msg,btn = setting_msg_btn(self)
        k = self.get_btn_key_as_text(self.get_text())
        if k in btn:
            msg='enter_new_value'
            self.userdata('set_key',k)
            self.send(msg,[[self.back_menu_key]])
            return self.stat_key(key,1)
        else:
            btn+=[self.back_menu_key]
            self.send(msg,chunks(btn,2),col=2,translat=False)
            return self.stat_key(key,0)
    s.callback=act


    s1=Node()
    s1.filters = Filters.text
    def act(self:Conversation,*args):
        k = self.userdata('set_key')
        if self.set_setting(k,self.get_text()):
            self.send('updated')
        else:
            self.send(self.text('bad_input',slash=True)+'\n'+self.text('enter_new_value',slash=True))
            return self.stat_key(key,1)

        msg,btn = setting_msg_btn(self)
        btn+=[self.back_menu_key]
        self.send(msg,chunks(btn,2),col=2,translat=False)
        return self.stat_key(key,0)
    s1.callback=act

    p.entry=[e]
    p.states=[[s],[s1]]

    return p
    


#************** not completed********************
def SupportAdmin(self:Conversation):
    p = Pack()
    p.name = 'SupportAdmin'
    p.db_config={'support': {'id':0,'u_id': 0, 'msg_id': 0, 'response_id': 0, 'responser_id': 0, 'extra': '', 'status': 0, 'time': 0}}
    e=Node()
    e.filters = match_btn('support',self)

    def show_message_from_user(self:Conversation, item):
        try:

            lnk = None
            u_username = self.user('username')
            if u_username != None:
                lnk = f'https://t.me/{u_username}'
            try:
                name = self.user('name')[:13]
            except:
                name = 'info'
            btn = {
                'send_reply': f"{item['id']}",
                'user_info': f"{item['u_id']}",
                'mark_read': f"{item['id']}",
                'show_response': f"{item['id']}",
                'perv_sup_pm': f"{item['id']}:{item['u_id']}",
                'next_sup_pm': f"{item['id']}:{item['u_id']}",
            }
            tbtn = btn.copy()
            tbtn[name] = f"shinfo:{item['id']}"
            if lnk:
                tbtn['pv'] = lnk
            
            try:
                self.copy_message(from_chat_id=item['u_id'],message_id=item['msg_id'],chat_id=self.id,btns=tbtn)
            except:
                try:
                    btn['info'] = f"shinfo:{item['time']}"
                    if lnk:
                        btn['pv'] = lnk
                        self.copy_message(from_chat_id=item['u_id'],message_id=item['msg_id'],chat_id=self.id,btns=tbtn)
                except:
                    self.send('unreadable_message'+f"\n/user_{item['u_id']}", btn)
                    self.db.do('support', {'status': 1},condition=f"id={item['id']}")
        except Exception as e:
            self.send_message('unreadable_message'+f"\n/user_{item['u_id']}\nerror")
            self.db.do('support', {'status': 1},condition=f"id={item['id']}")
            self.debug.debug(e)


    def unreaded_messages(self:Conversation, *args):
        unreaded_messages = self.db.do('support', condition=f"status=0")
        self.send('wait', self.menu_btn)
        try:
            if not unreaded_messages:
                self.send('no_item', self.menu_keys)
            else:
                for item in unreaded_messages:
                    self.show_message_from_user(item)
        except Exception as e:
            self.debug.debug(e)
        return -1
    e.callback = unreaded_messages
    p.entry=[e]
    return p


    
    